diff --git a/src/isdn/Q921.c b/src/isdn/Q921.c
index 2dad5cf..a682c23 100644
--- a/src/isdn/Q921.c
+++ b/src/isdn/Q921.c
@@ -479,80 +2903,597 @@ int Q921ProcSABME(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
 *****************************************************************************/
 int Q921Rx12(L2TRUNK trunk)
 {
-    L2UCHAR *mes;
-    L2INT rs,size;     /* receive size & Q921 frame size*/
-    L2UCHAR *smes = MFIFOGetMesPtr(trunk->HDLCInQueue, &size);
-	L2UCHAR nr;
-
-    if(smes != NULL)
-    {
-        rs = size - trunk->Q921HeaderSpace;
-        mes = &smes[trunk->Q921HeaderSpace];
-
-		if ((mes[2] & 3) != 3) {
-			/* we have an S or I frame */
-			/* if nr is between va and vs, update our va counter */
-			nr = (mes[3] >> 1);
-			if (nr >= trunk->va && nr <= trunk->vs) {
-				trunk->va = nr;
-			}
-		}
-
-        /* check for I frame */
-        if((mes[2] & 0x01) == 0)
-        {
-
-			/* we increment before we "really" know its good so that if we send in the callback, we use the right nr */
-			trunk->vr++;
-            if(Q921Tx23Proc(trunk, smes, size-2)) /* -2 to clip away CRC */
-            {
-				Q921SendRR(trunk, (mes[0]&0xfc)>>2, (mes[0]>>1)&0x01, mes[1]>>1, mes[3]&0x01);
-			}
-            else
-            {
-                /* todo: whatever*/
-				/* trunk->vr--; */
-				/* for now, lets just respond for easier debugging on errors */
-				Q921SendRR(trunk, (mes[0]&0xfc)>>2, (mes[0]>>1)&0x01, mes[1]>>1, mes[3]&0x01);
-           }
-        }
-
-        /* check for RR */
-        else if(mes[2] ==0x01)
+	L2INT size;     /* receive size & Q921 frame size*/
+	L2UCHAR *smes = MFIFOGetMesPtr(trunk->HDLCInQueue, &size);
+
+	if(smes)
+	{
+		struct Q921_Link *link;
+		L2UCHAR sapi, tei;
+		L2UCHAR *mes;
+		L2INT rs;
+
+		rs  = size - trunk->Q921HeaderSpace;
+		mes = &smes[trunk->Q921HeaderSpace];
+
+		Q921LogMesg(trunk, Q921_LOG_DEBUG, 1, mes, rs, "New packet received (%d bytes)", rs);
+
+		/* common fields: get sapi, tei and cr */
+		sapi = (mes[0] & 0xfc) >> 2;
+		tei  = (mes[1] & 0xfe) >> 1;
+		link  = Q921_LINK_CONTEXT(trunk, tei);
+
+		if(Q921_IS_PTMP_TE(trunk) && (
+			 (link->state >= Q921_STATE_TEI_ASSIGNED && tei != link->tei && tei != Q921_TEI_BCAST) ||			/* Assigned TEI: Only BCAST and directed */
+			 (link->state == Q921_STATE_TEI_UNASSIGNED && tei != Q921_TEI_BCAST)))					/* No assigned TEI: Only BCAST */
 		{
-			if (((mes[0]>>1)&0x01) == (trunk->NetUser == Q921_TE ? 1 : 0)) { /* if this is a command */
-				Q921SendRR(trunk, (mes[0]&0xfc)>>2, (mes[0]>>1)&0x01, mes[1]>>1, mes[2]&0x01);
+			/* Ignore Messages with foreign TEIs */
+			goto out;
+		}
+
+		if((mes[2] & 0x01) == 0x00) {		/* I frame */
+			Q921ProcIFrame(trunk, mes, rs);
+		}
+		else if((mes[2] & 0x03) == 0x01) {	/* S frame */
+			Q921ProcSFrame(trunk, mes, rs);
+		}
+		else if((mes[2] & 0x03) == 0x03) {	/* U frame */
+			Q921ProcUFrame(trunk, mes, rs);
+		}
+		else {
+			Q921Log(trunk, Q921_LOG_ERROR, "Invalid frame type: %d\n", (int)(mes[2] & 0x03));
+			/* TODO: send FRMR or REJ */
+		}
+
+out:
+		MFIFOKillNext(trunk->HDLCInQueue);
+
+		return 1;
+	}
+
+	return 0;
+}
+
+/*
+ * Misc
+ */
+/**
+ * Q921SetLogCB
+ * \brief	Set logging callback
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	func	pointer to logging callback function
+ * \param[in]	priv	pointer to private data
+ *
+ * \author	Stefan Knoblich
+ */
+void Q921SetLogCB(L2TRUNK trunk, Q921LogCB_t func, void *priv)
+{
+	if(!trunk)
+		return;
+
+	trunk->Q921LogProc = func;
+	trunk->PrivateDataLog = priv;
+}
+
+/**
+ * Q921SetLogLevel
+ * \brief	Set loglevel of Q.921 logging functions
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	level	new loglevel
+ *
+ * \author	Stefan Knoblich
+ */
+void Q921SetLogLevel(L2TRUNK trunk, Q921LogLevel_t level)
+{
+	if(!trunk)
+		return;
+
+	trunk->loglevel = level;
+}
+
+
+/**
+ * Q921ChangeState
+ * \brief	Change state, invoke neccessary actions
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	state	state to change to
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921ChangeState(L2TRUNK trunk, Q921State_t state, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+	Q921State_t oldstate = link->state;
+	int res = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Changing state from \"%s\" (%d) to \"%s\" (%d) for TEI %d\n",
+				Q921State2Name(oldstate), oldstate,
+				Q921State2Name(state), state,
+				tei);
+
+	/*
+	 * generic actions (depending on the target state only)
+	 */
+	switch(state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+		/* Start TM01 */
+		if(Q921_IS_NT(trunk)) {
+			Q921TM01TimerStart(trunk, tei);
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	/*
+	 * actions that depend on type of the old -> new state transition
+	 */
+	switch(oldstate) {
+	case Q921_STATE_STOPPED:
+
+		switch(state) {
+		case Q921_STATE_TEI_UNASSIGNED:
+			if(Q921_IS_PTMP_TE(trunk)) {
+				res = Q921TeiSendAssignRequest(trunk);
 			}
+			break;
 
-        }
-		
-        /* check for RNR */
-        /* check for REJ */
-        /* check for SABME */
-        else if((mes[2] & 0xef) == 0x6f)
-        {
-            Q921ProcSABME(trunk, mes, rs);
-            Q921SendUA(trunk, (mes[0]&0xfc)>>2, (mes[0]>>1)&0x01,mes[1]>>1, (mes[2]&0x10)>>4);
-        }
-
-        /* check for DM */
-        /* check for UI */
-        /* check for DISC */
-        /* check for UA */
-        /* check for FRMR */
-        /* check for XID */
-
-        else
-        {
-            /* what the ? Issue an error */
-			/* Q921ErrorProc(trunk, Q921_UNKNOWNFRAME, mes, rs); */
-            /* todo: REJ or FRMR */
-        }
-
-        MFIFOKillNext(trunk->HDLCInQueue);
-
-        return 1;
-    }
-    return 0;
+		case Q921_STATE_TEI_ASSIGNED:
+			if(Q921_IS_PTMP_NT(trunk)) {
+				res = Q921TeiSendRemoveRequest(trunk, Q921_TEI_BCAST);
+			}
+			break;
+
+		default:
+			break;
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	link->state = state;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Q921ChangeState() returns %d, new state is \"%s\" (%d) for TEI %d\n", res, Q921State2Name(state), state, tei);
+
+	return res;
+}
+
+/*
+ * TEI Management functions
+ * \note	All TEI-mgmt UN frames are sent with cr = command!
+ */
+static int Q921TeiSend(L2TRUNK trunk, L2UCHAR type, L2USHORT ri, L2UCHAR ai)
+{
+	L2UCHAR mes[10];
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+
+	mes[offset++] = Q921_LAYER_ENT_ID_TEI;	/* layer management entity identifier */
+	mes[offset++] = (ri & 0xff00) >> 8;	/* reference number upper part */
+	mes[offset++] =  ri & 0xff;		/* reference number lower part */
+	mes[offset++] = type;			/* message type: Identity Request */
+	mes[offset++] = ai << 1 | 0x01;		/* action indicator: TEI */
+
+	return Q921SendU(trunk, Q921_SAPI_TEI, Q921_COMMAND(trunk), Q921_TEI_BCAST, 0, 0x00, mes, offset);
+}
+
+
+/**
+ * Q921TeiSendAssignRequest
+ * \brief	Ask for new TEI (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success, <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendAssignRequest(L2TRUNK trunk)
+{
+	struct Q921_Link *link = Q921_TRUNK_CONTEXT(trunk);
+	L2INT res;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* only ptmp te mode*/
+		return 0;
+
+	link->ri = (L2USHORT)(random() % 0xffff);
+
+	/* send TEI assign request */
+	res = Q921TeiSend(trunk, Q921_TEI_ID_REQUEST, link->ri, Q921_TEI_BCAST);
+
+	/* start T202 */
+	Q921T202TimerStart(trunk);
+
+	return res;
 }
 
+
+/**
+ * Q921TeiProcessAssignResponse
+ * \brief	Process assign response (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcAssignResponse(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	struct Q921_Link *link = Q921_TRUNK_CONTEXT(trunk);
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2USHORT ri = 0;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* PTMP TE only */
+		return 0;
+
+	ri = (mes[offset + 1] << 8) | mes[offset + 2];
+
+	if(ri != link->ri) {
+		/* hmmm ..., not our response i guess */
+		return 0;
+	}
+
+	switch(mes[offset + 3]) {
+	case Q921_TEI_ID_ASSIGNED:
+		/* Yay, use the new TEI and change state to assigned */
+		link->tei      = mes[offset + 4] >> 1;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "Assigned TEI %d, setting state to TEI_ASSIGNED\n", link->tei);
+
+		Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED, link->tei);
+		break;
+
+	case Q921_TEI_ID_DENIED:
+		/* oops, what to do now? */
+		if ((mes[offset + 4] >> 1) == Q921_TEI_BCAST) {
+			/* No more free TEIs? this is bad */
+
+			//Q921TeiSendVerifyRequest(trunk, Q921_TEI_BCAST); /* TODO: does this work ?? */
+		} else {
+			/* other reason, this is fatal, shutdown link */
+		}
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "TEI assignment has been denied, reason: %s\n",
+			 ((mes[offset +4] >> 1) == Q921_TEI_BCAST) ? "No free TEIs available" : "Unknown");
+
+		Q921ChangeState(trunk, Q921_STATE_TEI_UNASSIGNED, link->tei);
+		break;
+
+	default:
+		return 0;
+	}
+
+	/* stop T202 */
+	Q921T202TimerStop(trunk);
+
+	return 1;
+}
+
+
+/**
+ * Q921TeiSendVerifyRequest
+ * \brief	Verify TEI (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendVerifyRequest(L2TRUNK trunk)
+{
+	struct Q921_Link *link = Q921_TRUNK_CONTEXT(trunk);
+	L2INT res;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* only ptmp te mode*/
+		return 0;
+
+	/* Request running? */
+	if (trunk->T202)
+		return 0;
+
+	/* Send TEI verify request */
+	res = Q921TeiSend(trunk, Q921_TEI_ID_VERIFY, link->ri, link->tei);
+
+	/* start T202 */
+	Q921T202TimerStart(trunk);
+
+	return res;
+}
+
+
+/**
+ * Q921TeiProcCheckRequest
+ * \brief	Process Check Request (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcCheckRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	struct Q921_Link *link = Q921_TRUNK_CONTEXT(trunk);
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2UCHAR tei = (mes[offset + 4] >> 1);		/* action indicator => tei */
+	L2INT res = 0;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* ptmp te mode only */
+		return 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Received TEI Check request for TEI %d\n", tei);
+
+	if (tei == Q921_TEI_BCAST || tei == link->tei) {
+		/*
+		 * Broadcast TEI check or for our assigned TEI
+		 */
+
+		/* send TEI check reponse */
+		res = Q921TeiSend(trunk, Q921_TEI_ID_CHECKRESP, link->ri, link->tei);
+
+		Q921T202TimerStop(trunk);
+	}
+
+	return res;
+}
+
+
+/**
+ * Q921TeiProcRemoveRequest
+ * \brief	Process remove Request (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcRemoveRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	struct Q921_Link *link = Q921_TRUNK_CONTEXT(trunk);
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2UCHAR tei = (mes[offset + 4] >> 1);		/* action indicator => tei */
+	L2INT res = 0;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* ptmp te mode only */
+		return 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Received TEI Remove request for TEI %d\n", tei);
+
+	if (tei == Q921_TEI_BCAST || tei == link->tei) {
+		/*
+		 * Broadcast TEI remove or for our assigned TEI
+		 */
+
+		/* reset tei */
+		link->tei  = 0;
+
+		/* change state (no action) */
+		Q921ChangeState(trunk, Q921_STATE_TEI_UNASSIGNED, link->tei);
+
+		/* TODO: hmm, request new one ? */
+		res = Q921TeiSendAssignRequest(trunk);
+	}
+	return res;
+}
+
+
+/**
+ * Q921TeiProcAssignRequest
+ * \brief	Process assign request from peer (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcAssignRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2USHORT ri = 0;
+	L2UCHAR tei = 0;
+
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	ri  = (mes[offset + 1] << 8) | mes[offset + 2];
+	tei =  mes[offset + 4] >> 1;
+
+	if(tei == Q921_TEI_BCAST) {
+		int x;
+
+		/* dynamically allocate TEI */
+		for(x = Q921_TEI_DYN_MIN, tei = 0; x <= Q921_TEI_MAX; x++) {
+			if(!trunk->tei_map[x]) {
+				tei = x;
+				break;
+			}
+		}
+	}
+	else if(!(tei > 0 && tei < Q921_TEI_DYN_MIN)) {
+		/* reject TEIs that are not in the static area */
+		Q921TeiSendDenyResponse(trunk, 0, ri);
+
+		return 0;
+	}
+
+	if(!tei) {
+		/* no free TEI found */
+		Q921TeiSendDenyResponse(trunk, Q921_TEI_BCAST, ri);
+	}
+	else {
+		struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+		/* mark used */
+		trunk->tei_map[tei] = 1;
+
+		/* assign tei */
+		link->tei = tei;
+
+		/* put context in TEI ASSIGNED state */
+		Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED, tei);
+
+		/* send assign response */
+		Q921TeiSendAssignedResponse(trunk, tei, ri);
+
+		/* Start T201 */
+		Q921T201TimerStart(trunk, tei);
+	}
+	return 0;
+}
+
+/**
+ * Q921TeiSendCheckRequest
+ * \brief	Send check request (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	tei	TEI to check
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendCheckRequest(L2TRUNK trunk, L2UCHAR tei)
+{
+	L2INT res = 0;
+
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	/* send TEI check request */
+	res = Q921TeiSend(trunk, Q921_TEI_ID_CHECKREQ, 0, tei);
+
+	/* (Re-)Start T201 timer */
+	Q921T201TimerStart(trunk, tei);
+
+	return res;
+}
+
+/**
+ * Q921TeiProcCheckResponse
+ * \brief	Process Check Response (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcCheckResponse(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	struct Q921_Link *link;
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2USHORT ri = 0;
+	L2UCHAR tei = 0;
+
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT mode only */
+		return 0;
+
+	ri  = (mes[offset + 1] << 8) | mes[offset + 2];
+	tei =  mes[offset + 4] >> 1;
+
+	/* restart T201 */
+	Q921T201TimerStop(trunk, tei);
+
+	/* reset counter */
+	link       = Q921_LINK_CONTEXT(trunk, tei);
+	link->N202 = 0;
+
+	if(!(tei > 0 && tei < Q921_TEI_MAX) || !trunk->tei_map[tei]) {
+		/* TODO: Should we send a DISC first? */
+
+		/* TEI not assigned? Invalid TEI? */
+		Q921TeiSendRemoveRequest(trunk, tei);
+
+		/* change state */
+		Q921ChangeState(trunk, Q921_STATE_STOPPED, tei);
+
+		/* clear */
+		memset(link, 0, sizeof(struct Q921_Link));
+	} else {
+		/* Start T201 */
+		Q921T201TimerStart(trunk, tei);
+	}
+
+	return 0;
+}
+
+
+/**
+ * Q921TeiProcVerifyRequest
+ * \brief	Process Verify Request (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcVerifyRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR resp[25];
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2UCHAR tei = 0;
+
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT mode only */
+		return 0;
+
+	tei = mes[offset + 4] >> 1;
+
+	/* todo: handle response... verify assigned TEI */
+	resp[offset + 0] = 0;
+
+	return 0;
+}
+
+/**
+ * Q921TeiSendDenyResponse
+ * \brief	Send Deny Response (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendDenyResponse(L2TRUNK trunk, L2UCHAR tei, L2USHORT ri)
+{
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	return Q921TeiSend(trunk, Q921_TEI_ID_DENIED, ri, tei);
+}
+
+
+/**
+ * Q921TeiSendAssignedResponse
+ * \brief	Send Assigned Response (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	tei	TEI to assign
+ * \param[in]	ri	RI of request
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendAssignedResponse(L2TRUNK trunk, L2UCHAR tei, L2USHORT ri)
+{
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	return Q921TeiSend(trunk, Q921_TEI_ID_ASSIGNED, ri, tei);
+}
+
+/**
+ * Q921TeiSendRemoveRequest
+ * \brief	Send Remove Request (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	tei	TEI to remove
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendRemoveRequest(L2TRUNK trunk, L2UCHAR tei)
+{
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	return Q921TeiSend(trunk, Q921_TEI_ID_REMOVE, 0, tei);
+}
diff --git a/src/isdn/Q931.c b/src/isdn/Q931.c
index 12ebde2..0cede6f 100644
--- a/src/isdn/Q931.c
+++ b/src/isdn/Q931.c
@@ -36,6 +36,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 *****************************************************************************/
 
+#include "Q921.h"
 #include "Q931.h"
 #include "national.h"
 #include "DMS.h"
@@ -67,6 +68,8 @@ q931pmes_func_t *Q931Pmes[Q931MAXDLCT][Q931MAXMES];
 q931uie_func_t *Q931Uie[Q931MAXDLCT][Q931MAXIE];
 q931pie_func_t *Q931Pie[Q931MAXDLCT][Q931MAXIE];
 
+q931timeout_func_t *Q931Timeout[Q931MAXDLCT][Q931MAXTIMER];
+q931timer_t         Q931Timer[Q931MAXDLCT][Q931MAXTIMER];
 
 void  (*Q931CreateDialectCB[Q931MAXDLCT])       (L3UCHAR iDialect)=
 {
@@ -250,6 +253,10 @@ void Q931Initialize()
             Q931Pie[x][y] = Q931PieDummy;
             Q931Uie[x][y] = Q931UieDummy;
         }
+	for(y=0; y < Q931MAXTIMER; y++) {
+		Q931Timeout[x][y] = Q931TimeoutDummy;
+		Q931Timer[x][y]   = 0;
+	}
     }
 
     if(Q931CreateDialectCB[Q931_Dialect_Q931 + Q931_TE] == NULL)
@@ -286,28 +293,38 @@ void Q931Initialize()
     }
 }
 
-/*****************************************************************************
-
-  Function:     Q931TimeTick
-
-  Description:  Called periodically from an external source to allow the 
-                stack to process and maintain it's own timers.
-
-  Parameters:   ms[IN]        Milliseconds since last call.
-
-  Return Value: none
-
-*****************************************************************************/
-void Q931TimeTick(Q931_TrunkInfo_t *pTrunk, L3ULONG ms)
-{
-    (void)pTrunk;
-    ms=ms; /* avoid warning for now. */
-
-    /*  TODO: Loop through all active calls, check timers and call timout procs
-     *  if timers are expired.
-     *  Implement a function array so each dialect can deal with their own
-     *  timeouts.
-    */
+/**
+ * Q931TimerTick
+ * \brief	Periodically called to update and check for expired timers
+ * \param	pTrunk	Q.931 trunk
+ */
+void Q931TimerTick(Q931_TrunkInfo_t *pTrunk)
+{
+	struct Q931_Call *call = NULL;
+	L3ULONG now = 0;
+	L3INT x;
+
+	/*  TODO: Loop through all active calls, check timers and call timout procs
+	 *  if timers are expired.
+	 *  Implement a function array so each dialect can deal with their own
+	 *  timeouts.
+	 */
+	now = Q931GetTime();
+
+	for(x = 0; x < Q931MAXCALLPERTRUNK; x++) {
+		call = &pTrunk->call[x];
+
+		if(!call->InUse || !call->Timer || !call->TimerID)
+			continue;
+
+		if(call->Timer <= now) {
+			/* Stop Timer */
+			Q931StopTimer(pTrunk, x, call->TimerID);
+
+			/* Invoke dialect timeout callback */
+			Q931Timeout[pTrunk->Dialect][call->TimerID](pTrunk, x);
+		}
+	}
 }
 
 /*****************************************************************************
@@ -331,39 +348,65 @@ void Q931TimeTick(Q931_TrunkInfo_t *pTrunk, L3ULONG ms)
                 see q931errors.h for details.
 
 *****************************************************************************/
-L3INT Q931Rx23(Q931_TrunkInfo_t *pTrunk, L3UCHAR * buf, L3INT Size)
-{
-    L3UCHAR *Mes = &buf[Q931L2HeaderSpace];
-    L3INT RetCode = Q931E_NO_ERROR;
-    Q931mes_Generic *m = (Q931mes_Generic *) pTrunk->L3Buf;
-    L3INT ISize;
-
-    L3INT IOff = 0;
-
-	/* Reset our decode buffer */
-	memset(pTrunk->L3Buf, 0, sizeof(pTrunk->L3Buf));
-
-	/* Protocol Discriminator */
-    m->ProtDisc = Mes[IOff++];
-
-    /* CRV */
-    m->CRVFlag = Mes[IOff + 1] & 0x80;
-    m->CRV = Q931Uie_CRV(pTrunk, Mes, m->buf, &IOff, &ISize);
-
-    /* Message Type */
-    m->MesType = Mes[IOff++];
-
-    /* Call table proc to unpack codec message */
-    /*debug */
-    /* printf("\n\nQ931Rx23-  Dialect: %d, MsgType: %d\n",pTrunk->Dialect,m->MesType); */
-    RetCode = Q931Umes[pTrunk->Dialect][m->MesType](pTrunk, Mes, (Q931mes_Generic *)pTrunk->L3Buf, Q931L4HeaderSpace + IOff , Size - Q931L4HeaderSpace - IOff + 1);
-
-    if(RetCode >= Q931E_NO_ERROR)
-    {
-        RetCode = Q931Proc[pTrunk->Dialect][m->MesType](pTrunk, pTrunk->L3Buf, 2);
-    }
+L3INT Q931Rx23(Q931_TrunkInfo_t *pTrunk, L3INT ind, L3UCHAR tei, L3UCHAR * buf, L3INT Size)
+{
+	L3UCHAR *Mes = NULL;
+	L3INT RetCode = Q931E_NO_ERROR;
+	Q931mes_Generic *m = (Q931mes_Generic *) pTrunk->L3Buf;
+	L3INT ISize;
+	L3INT IOff = 0;
+	L3INT L2HSize = Q931L2HeaderSpace;
+
+	switch(ind) {
+	case Q921_DL_UNIT_DATA:		/* DL-UNITDATA indication (UI frame, 3 byte header) */
+		L2HSize = 3;
+
+	case Q921_DL_DATA:		/* DL-DATA indication (I frame, 4 byte header) */
+		/* Reset our decode buffer */
+		memset(pTrunk->L3Buf, 0, sizeof(pTrunk->L3Buf));
+
+		/* L2 Header Offset */
+		Mes = &buf[L2HSize];
+
+		/* Protocol Discriminator */
+		m->ProtDisc = Mes[IOff++];
+
+		/* CRV */
+		m->CRVFlag = (Mes[IOff + 1] >> 7) & 0x01;
+		m->CRV = Q931Uie_CRV(pTrunk, Mes, m->buf, &IOff, &ISize);
+
+		/* Message Type */
+		m->MesType = Mes[IOff++];
+
+		/* d'oh a little ugly but this saves us from:
+		 *	a) doing Q.921 work in the lower levels (extracting the TEI ourselves)
+		 *	b) adding a tei parameter to _all_ Proc functions
+		 */
+		if(tei) {
+			L3INT callIndex = 0;
+
+			/* Find the call using CRV */
+			RetCode = Q931FindCRV(pTrunk, m->CRV, &callIndex);
+			if(RetCode == Q931E_NO_ERROR && !pTrunk->call[callIndex].Tei) {
+				pTrunk->call[callIndex].Tei = tei;
+			}
+		}
+
+		Q931Log(pTrunk, Q931_LOG_DEBUG, "Received message from Q.921 (ind %d, tei %d, size %d)\nMesType: %d, CRVFlag %d (%s), CRV %d (Dialect: %d)\n", ind, tei, Size,
+						 m->MesType, m->CRVFlag, m->CRVFlag ? "Terminator" : "Originator", m->CRV, pTrunk->Dialect);
+
+		RetCode = Q931Umes[pTrunk->Dialect][m->MesType](pTrunk, Mes, (Q931mes_Generic *)pTrunk->L3Buf, IOff, Size - L2HSize);
+		if(RetCode >= Q931E_NO_ERROR)
+		{
+			RetCode = Q931Proc[pTrunk->Dialect][m->MesType](pTrunk, pTrunk->L3Buf, 2);
+		}
+		break;
+
+	default:
+		break;
+	}
 
-    return RetCode;
+	return RetCode;
 }
 
 /*****************************************************************************
@@ -381,6 +424,8 @@ L3INT Q931Rx23(Q931_TrunkInfo_t *pTrunk, L3UCHAR * buf, L3INT Size)
 *****************************************************************************/
 L3INT Q931Tx34(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
 {
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Sending message to Layer4 (size: %d)\n", Size);
+
     if (pTrunk->Q931Tx34CBProc) {
         return pTrunk->Q931Tx34CBProc(pTrunk->PrivateData34, Mes, Size);
     }
@@ -406,7 +451,11 @@ L3INT Q931Rx43(Q931_TrunkInfo_t *pTrunk,L3UCHAR * buf, L3INT Size)
     Q931mes_Header *ptr = (Q931mes_Header*)&buf[Q931L4HeaderSpace];
     L3INT RetCode = Q931E_NO_ERROR;
 
-    RetCode=Q931Proc[pTrunk->Dialect][ptr->MesType](pTrunk,buf,4);
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Receiving message from Layer4 (size: %d, type: %d)\n", Size, ptr->MesType);
+
+    RetCode = Q931Proc[pTrunk->Dialect][ptr->MesType](pTrunk, buf, 4);
+
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Q931Rx43 return code: %d\n", RetCode);
 
     return RetCode;
 }
@@ -428,25 +477,40 @@ L3INT Q931Rx43(Q931_TrunkInfo_t *pTrunk,L3UCHAR * buf, L3INT Size)
                 see q931errors.h for details.
 
 *****************************************************************************/
-L3INT Q931Tx32(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
+L3INT Q931Tx32Data(Q931_TrunkInfo_t *pTrunk, L3UCHAR bcast, L3UCHAR * Mes, L3INT Size)
 {
-    L3INT     OSize;
-    Q931mes_Generic *ptr = (Q931mes_Generic*)Mes;
-    L3INT RetCode = Q931E_NO_ERROR;
-    L3INT iDialect = pTrunk->Dialect;
+	Q931mes_Generic *ptr = (Q931mes_Generic*)Mes;
+	L3INT RetCode = Q931E_NO_ERROR;
+	L3INT iDialect = pTrunk->Dialect;
+	L3INT Offset = bcast ? (Q931L2HeaderSpace - 1) : Q931L2HeaderSpace;
+	L3INT OSize;
 
-    /* Call pack function through table. */
-    RetCode = Q931Pmes[iDialect][ptr->MesType](pTrunk, (Q931mes_Generic *)Mes, Size, &pTrunk->L2Buf[Q931L2HeaderSpace], &OSize);
-    if(RetCode >= Q931E_NO_ERROR)
-    {
-        if (pTrunk->Q931Tx32CBProc) {
-            RetCode = pTrunk->Q931Tx32CBProc(pTrunk->PrivateData32, pTrunk->L2Buf, OSize + Q931L2HeaderSpace);
-        } else {
-            RetCode = Q931E_MISSING_CB;
-        }
-    }
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Sending message to Q.921 (size: %d)\n", Size);
 
-    return RetCode;
+	memset(pTrunk->L2Buf, 0, sizeof(pTrunk->L2Buf));
+
+	/* Call pack function through table. */
+	RetCode = Q931Pmes[iDialect][ptr->MesType](pTrunk, (Q931mes_Generic *)Mes, Size, &pTrunk->L2Buf[Offset], &OSize);
+	if(RetCode >= Q931E_NO_ERROR)
+	{
+		L3INT callIndex;
+		L3UCHAR tei = 0;
+
+		/* Find the call using CRV */
+		RetCode = Q931FindCRV(pTrunk, ptr->CRV, &callIndex);
+		if(RetCode != Q931E_NO_ERROR)
+			return RetCode;
+
+		tei = pTrunk->call[callIndex].Tei;
+
+		if (pTrunk->Q931Tx32CBProc) {
+			RetCode = pTrunk->Q931Tx32CBProc(pTrunk->PrivateData32, bcast ? Q921_DL_UNIT_DATA : Q921_DL_DATA, tei, pTrunk->L2Buf, OSize + Offset);
+		} else {
+			RetCode = Q931E_MISSING_CB;
+		}
+	}
+
+	return RetCode;
 }
 
 
@@ -575,28 +639,40 @@ L3INT    Q931GetCallState(Q931_TrunkInfo_t *pTrunk, L3INT iCRV)
     return 0; /* assume state zero for non existing CRV's */
 }
 
-/*****************************************************************************
-
-  Function:     Q931StartTimer
-
-  Description:  Start a timer.
-
-  Parameters:   pTrunk      Trunk number
-                callindex   call index.
-                iTimer      timer id
-*****************************************************************************/
+/**
+ * Q931StartTimer
+ * \brief	Start a timer
+ * \param	pTrunk		Q.931 trunk
+ * \param	callindex	Index of the call
+ * \param	iTimerID	ID of timer
+ * \return	always 0
+ */
 L3INT Q931StartTimer(Q931_TrunkInfo_t *pTrunk, L3INT callIndex, L3USHORT iTimerID)
 {
-    pTrunk->call[callIndex].Timer   = Q931GetTime();  
-    pTrunk->call[callIndex].TimerID = iTimerID;
-    return 0;
+	L3ULONG duration = Q931Timer[pTrunk->Dialect][iTimerID];
+
+	if(duration) {
+		pTrunk->call[callIndex].Timer   = Q931GetTime() + duration;
+		pTrunk->call[callIndex].TimerID = iTimerID;
+	}
+
+	return 0;
 }
 
+/**
+ * Q931StopTimer
+ * \brief	Stop a timer
+ * \param	pTrunk		Q.931 trunk
+ * \param	callindex	Index of the call
+ * \param	iTimerID	ID of timer
+ * \return	always 0
+ */
 L3INT Q931StopTimer(Q931_TrunkInfo_t *pTrunk, L3INT callindex, L3USHORT iTimerID)
 {
-    if(pTrunk->call[callindex].TimerID == iTimerID)
-        pTrunk->call[callindex].TimerID = 0;
-    return 0;
+	if(pTrunk->call[callindex].TimerID == iTimerID)
+		pTrunk->call[callindex].TimerID = 0;
+
+	return 0;
 }
 
 L3INT Q931SetState(Q931_TrunkInfo_t *pTrunk, L3INT callIndex, L3INT iState)
@@ -609,7 +685,8 @@ L3INT Q931SetState(Q931_TrunkInfo_t *pTrunk, L3INT callIndex, L3INT iState)
 L3ULONG Q931GetTime()
 {
     L3ULONG tNow = 0;
-    static L3ULONG tLast={0};
+    static L3ULONG tLast = 0;
+
     if(Q931GetTimeProc != NULL)
     {
         tNow = Q931GetTimeProc();
@@ -758,5 +835,68 @@ const char *q931_error_to_name(q931_error_t error)
     }
     return q931_error_names[index];
 }
+/*
+ * Logging
+ */
+#include <stdarg.h>
+
+L3INT Q931Log(Q931_TrunkInfo_t *trunk, Q931LogLevel_t level, const char *fmt, ...)
+{
+	char  buf[Q931_LOGBUFSIZE];
+	L3INT len;
+	va_list ap;
+
+	if(!trunk->Q931LogCBProc)
+		return 0;
+
+	if(trunk->loglevel < level)
+		return 0;
+
+	va_start(ap, fmt);
+
+	len = vsnprintf(buf, sizeof(buf)-1, fmt, ap);
+	if(len <= 0) {
+		/* TODO: error handling */
+		return -1;
+	}
+	if(len >= sizeof(buf))
+		len = sizeof(buf) - 1;
+
+	buf[len] = '\0';
+
+	va_end(ap);
+
+	return trunk->Q931LogCBProc(trunk->PrivateDataLog, level, buf, len);
+}
 
+/**
+ * Q921SetLogCB
+ * \brief	Set Logging callback function and private data
+ */
+void Q931SetLogCB(Q931_TrunkInfo_t *trunk, Q931LogCB_t func, void *priv)
+{
+	trunk->Q931LogCBProc = func;
+	trunk->PrivateDataLog = priv;
+}
+
+/**
+ * Q921SetLogLevel
+ * \brief	Set Loglevel
+ */
+void Q931SetLogLevel(Q931_TrunkInfo_t *trunk, Q931LogLevel_t level)
+{
+	trunk->loglevel = level;
+}
+
+/**
+ * Q931TimeoutDummy
+ * \brief	Dummy handler for timeouts
+ * \param	pTrunk		Q.931 trunk
+ * \param	callIndex	Index of call
+ */
+L3INT Q931TimeoutDummy(Q931_TrunkInfo_t *pTrunk, L3INT callIndex)
+{
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Timer %d of call %d (CRV: %d) timed out\n", pTrunk->call[callIndex].TimerID, callIndex, pTrunk->call[callIndex].CRV);
 
+	return 0;
+}
